#ifndef WORLD_H
#define WORLD_H

#include <iostream>
#include "Chunk.h"
#include "IChunkProvider.h"
#include "IChunkListener.h"
#include "../data/UnsortedArrayList.h"

using namespace std;

class World
{
public:
    World(IChunkProvider* chunks);
    virtual ~World();
    
    void registerChunkListener(IChunkListener* listener);
    void removeChunkListener(IChunkListener* listener);
    
    void updateDirtyChunks();
private:
    void updateChunk(Chunk& c);
    
    UnsortedArrayList<IChunkListener*> chunkListener;
    IChunkProvider* chunks;
};

#endif

